//Funktion zum Einlesen von PCX-Bildern by ...Adok...
//hurraaaaaa!

void loadpcxVESA(char *pcxname,char loadpal,int xpos,int ypos)
{
  FILE *pcxfile;
  unsigned char index      =0,
                temp,
                r,g,b;
  unsigned int  counter,
                screenx    =0,
                screeny    =0,
                x1,y1,
                x2,y2,
                xlen,ylen;
  unsigned long maxscreen,
                screenpos  =0;

  if( ( pcxfile=fopen(pcxname,"rb") ) == NULL )
  {
    screen(3);
    printf("PCX-Datei kann nicht geladen werden!");
    exit(1);
  }

  //Erste 4 Headerinfos bergehen
  for(counter=1; counter<=4; counter++)
    fgetc(pcxfile);

  //Koordinaten einlesen
  x1=fgetc(pcxfile); x1+=fgetc(pcxfile)<<8;
  y1=fgetc(pcxfile); y1+=fgetc(pcxfile)<<8;
  x2=fgetc(pcxfile); x2+=fgetc(pcxfile)<<8;
  y2=fgetc(pcxfile); y2+=fgetc(pcxfile)<<8;
  xlen=x2-x1;
  ylen=y2-y1;
  maxscreen=((long)xlen+1)*((long)ylen+1);

  //Restlichen Header bergehen
  for(counter=1; counter<=116; counter++)
    fgetc(pcxfile);

  // Pixeldaten einlesen
  do
  {
    if( index>0 )
    {
      temp=fgetc(pcxfile);
      for(counter=1; counter<=index; counter++)
      {
        psetVESA(screenx+xpos,screeny+ypos,temp);
        screenpos++;
        screenx++;
        if( screenx>xlen )
        {
          screeny++;
          screenx=0;
        }
      }
      index=0;
    }
    else
    {
     temp=fgetc(pcxfile);
     if( (temp&0xc0) == 0xc0 )
       index=(temp&0x3f);
     else
     {
       psetVESA(screenx+xpos,screeny+ypos,temp);
       screenpos++;
       screenx++;
       if( screenx>xlen )
       {
         screeny++;
         screenx=0;
       }
     }
    }
  } while( screenpos<maxscreen );

  if(loadpal!=0)
  {
    fseek(pcxfile,-768,SEEK_END);
    if(loadpal==1)
    {
      // Palette gleich laden
      for(counter=0; counter<=255; counter++)
      {
        r=fgetc(pcxfile)>>2;
        g=fgetc(pcxfile)>>2;
        b=fgetc(pcxfile)>>2;
        setpal(counter,r,g,b);
      }
    }
    else if(loadpal==2)
    {
      // Palette ins pcxpal-Datenfeld schreiben
      for(counter=0; counter<=767; counter++)
        pcxpal[counter]=( fgetc(pcxfile)>>2 );
    }
  }

  fclose(pcxfile);
}
